Index: g_macros.ddoc
===================================================================
--- g_macros.ddoc	(revision 0)
+++ g_macros.ddoc	(revision 0)
@@ -0,0 +1,1518 @@
+Pragma_production = $(GRAMMAR
+$(GNAME Pragma):
+    $(B pragma) $(B $(LPAREN)) $(I Identifier) $(B $(RPAREN))
+    $(B pragma) $(B $(LPAREN)) $(I Identifier) $(B ,) $(LINK2 expression.html#ArgumentList, $(I ArgumentList)) $(B $(RPAREN))
+)
+AttributeSpecifier_production = $(GRAMMAR
+$(GNAME AttributeSpecifier):
+    $(I Attribute) $(B :)
+    $(I Attribute) $(I DeclarationBlock)
+)
+Attribute_production = $(GRAMMAR
+$(GNAME Attribute):
+    $(LINK2 #linkage, $(I LinkageAttribute))
+    $(LINK2 #align, $(I AlignAttribute))
+    $(LINK2 pragma.html, $(I Pragma))
+    $(LINK2 #deprecated, $(B deprecated))
+    $(GLINK ProtectionAttribute)
+    $(B static)
+    $(B final)
+    $(LINK2 #override, $(B override))
+    $(LINK2 #abstract, $(B abstract))
+    $(LINK2 #const, $(B const))
+    $(LINK2 #auto, $(B auto))
+    $(LINK2 #scope, $(B scope))
+$(V2    $(LINK2 #gshared, $(B __gshared))
+)    $(LINK2 #shared, $(B shared))
+    $(LINK2 #immutable, $(B immutable))
+    $(LINK2 #inout, $(B inout))
+    $(LINK2 #disable, $(B @disable))
+)
+DeclarationBlock_production = $(GRAMMAR
+$(GNAME DeclarationBlock):
+    $(LINK2 module.html#DeclDef, $(I DeclDef))
+    $(B { })
+    $(B {) $(LINK2 module.html#DeclDefs, $(I DeclDefs)) $(B })
+)
+LinkageAttribute_production = $(GRAMMAR
+$(GNAME LinkageAttribute):
+	$(B extern)
+	$(B extern) $(B $(LPAREN)) $(I LinkageType) $(B $(RPAREN))
+)
+LinkageType_production = $(GRAMMAR
+$(GNAME LinkageType):
+	$(B C)
+	$(B C++)
+	$(B D)
+	$(B Windows)
+	$(B Pascal)
+	$(B System)
+)
+AlignAttribute_production = $(GRAMMAR
+$(GNAME AlignAttribute):
+	$(B align)
+	$(B align) $(B $(LPAREN)) $(I Integer) $(B $(RPAREN))
+)
+ProtectionAttribute_production = $(GRAMMAR
+$(GNAME ProtectionAttribute):
+    $(B private)
+    $(B package)
+    $(B protected)
+    $(B public)
+    $(B export)
+    $(B const)
+    $(B override)
+    $(B scope)
+    $(B auto)
+    $(B static)
+)
+ClassDeclaration_production = $(GRAMMAR
+$(GNAME ClassDeclaration):
+	$(B class) $(I Identifier) $(I BaseClassList) $(I ClassBody)
+	$(LINK2 template.html#ClassTemplateDeclaration, $(I ClassTemplateDeclaration))
+)
+BaseClassList_production = $(GRAMMAR
+$(GNAME BaseClassList):
+	$(I Empty)
+	$(B :) $(I SuperClass)
+	$(B :) $(I SuperClass) $(B ,) $(I InterfaceClasses)
+	$(B :) $(I InterfaceClass)
+)
+SuperClass_production = $(GRAMMAR
+$(GNAME SuperClass):
+	$(I Identifier)
+	$(I Protection) $(I Identifier)
+)
+InterfaceClasses_production = $(GRAMMAR
+$(GNAME InterfaceClasses):
+	$(I InterfaceClass)
+	$(I InterfaceClass) $(B ,) $(I InterfaceClasses)
+)
+InterfaceClass_production = $(GRAMMAR
+$(GNAME InterfaceClass):
+	$(I Identifier)
+	$(I Protection) $(I Identifier)
+)
+Protection_production = $(GRAMMAR
+$(GNAME Protection):
+	$(B private)
+	$(B package)
+	$(B public)
+	$(B export)
+)
+ClassBody_production = $(GRAMMAR
+$(GNAME ClassBody):
+	$(B {) $(B })
+	$(B {) $(I ClassBodyDeclarations) $(B })
+)
+ClassBodyDeclarations_production = $(GRAMMAR
+$(GNAME ClassBodyDeclarations):
+	$(I ClassBodyDeclaration)
+	$(I ClassBodyDeclaration) $(I ClassBodyDeclarations)
+)
+ClassBodyDeclaration_production = $(GRAMMAR
+$(GNAME ClassBodyDeclaration):
+	$(I Declaration)
+	$(GLINK Constructor)
+	$(GLINK Destructor)
+	$(GLINK StaticConstructor)
+	$(GLINK StaticDestructor)
+	$(GLINK Invariant)
+	$(GLINK UnitTest)
+	$(GLINK ClassAllocator)
+	$(GLINK ClassDeallocator)
+)
+Constructor_production = $(GRAMMAR
+$(GNAME Constructor):
+	$(B this) $(I Parameters) $(I FunctionBody)
+)
+Destructor_production = $(GRAMMAR
+$(GNAME Destructor):
+	$(B ~this()) $(I FunctionBody)
+)
+StaticConstructor_production = $(GRAMMAR
+$(GNAME StaticConstructor):
+	$(B static this()) $(I FunctionBody)
+)
+StaticDestructor_production = $(GRAMMAR
+$(GNAME StaticDestructor):
+	$(B static ~this()) $(I FunctionBody)
+)
+SharedStaticConstructor_production = $(GRAMMAR
+$(GNAME SharedStaticConstructor):
+	$(B shared static this()) $(I FunctionBody)
+)
+SharedStaticDestructor_production = $(GRAMMAR
+$(GNAME SharedStaticDestructor):
+	$(B shared static ~this()) $(I FunctionBody)
+)
+Invariant_production = $(GRAMMAR
+$(GNAME Invariant):
+	$(B invariant()) $(I BlockStatement)
+)
+ClassAllocator_production = $(GRAMMAR
+$(GNAME ClassAllocator):
+	$(B new) $(I Parameters) $(I FunctionBody)
+)
+ClassDeallocator_production = $(GRAMMAR
+$(GNAME ClassDeallocator):
+	$(B delete) $(I Parameters) $(I FunctionBody)
+)
+AliasThis_production = $(GRAMMAR
+$(GNAME AliasThis):
+	$(B alias) $(I Identifier) $(B this;)
+)
+NewAnonClassExpression_production = $(GRAMMAR
+$(GNAME NewAnonClassExpression):
+    $(B new) $(I PerenArgumentList)<sub>opt</sub> $(B class) $(I PerenArgumentList)<sub>opt</sub> $(I SuperClass)<sub>opt</sub> $(I InterfaceClasses)<sub>opt</sub> $(I ClassBody)
+)
+PerenArgumentList_production = $(GRAMMAR
+$(GNAME PerenArgumentList):
+    $(B $(LPAREN))$(I ArgumentList)$(B $(RPAREN))
+)
+Declaration_production = $(GRAMMAR
+$(GNAME Declaration):
+$(V1        $(B typedef) $(I Decl)
+)        $(B alias) $(I Decl)
+        $(I Decl)
+)
+Decl_production = $(GRAMMAR
+$(GNAME Decl):
+        $(GLINK StorageClasses) $(I Decl)
+        $(GLINK BasicType) $(GLINK Declarators) $(B ;)
+        $(GLINK BasicType) $(GLINK Declarator) $(LINK2 function.html#FunctionBody, $(I FunctionBody))
+	$(GLINK AutoDeclaration)
+)
+Declarators_production = $(GRAMMAR
+$(GNAME Declarators):
+        $(I DeclaratorInitializer)
+        $(I DeclaratorInitializer) $(B ,) $(GLINK DeclaratorIdentifierList)
+)
+DeclaratorInitializer_production = $(GRAMMAR
+$(GNAME DeclaratorInitializer):
+        $(GLINK Declarator)
+        $(GLINK Declarator) $(B =) $(GLINK Initializer)
+)
+DeclaratorIdentifierList_production = $(GRAMMAR
+$(GNAME DeclaratorIdentifierList):
+        $(GLINK DeclaratorIdentifier)
+        $(GLINK DeclaratorIdentifier) $(B ,) $(I DeclaratorIdentifierList)
+)
+DeclaratorIdentifier_production = $(GRAMMAR
+$(GNAME DeclaratorIdentifier):
+        $(I Identifier)
+        $(I Identifier) $(B =) $(GLINK Initializer)
+)
+BasicType_production = $(GRAMMAR
+$(GNAME BasicType):
+	$(GLINK BasicTypeX)
+        $(B .)$(GLINK IdentifierList)
+        $(GLINK IdentifierList)
+        $(GLINK Typeof)
+        $(GLINK Typeof) $(B .) $(GLINK IdentifierList)
+$(V2          $(B const$(LPAREN)) $(GLINK type) $(B $(RPAREN))
+        $(B immutable$(LPAREN)) $(GLINK type) $(B $(RPAREN))
+        $(B shared$(LPAREN)) $(GLINK type) $(B $(RPAREN))
+        $(B inout$(LPAREN)) $(GLINK type) $(B $(RPAREN))
+)
+)
+BasicTypeX_production = $(GRAMMAR
+$(GNAME BasicTypeX):
+        $(B bool)
+        $(B byte)
+        $(B ubyte)
+        $(B short)
+        $(B ushort)
+        $(B int)
+        $(B uint)
+        $(B long)
+        $(B ulong)
+        $(B char)
+        $(B wchar)
+        $(B dchar)
+        $(B float)
+        $(B double)
+        $(B real)
+        $(B ifloat)
+        $(B idouble)
+        $(B ireal)
+        $(B cfloat)
+        $(B cdouble)
+        $(B creal)
+        $(B void)
+)
+BasicType2_production = $(GRAMMAR
+$(GNAME BasicType2):
+        $(B *)
+        $(B [ ])
+        $(B [) $(VEXPRESSION) $(B ])
+        $(B [) $(VEXPRESSION) .. $(VEXPRESSION) $(B ])
+        $(B [) $(I Type) $(B ])
+        $(B delegate) $(GLINK Parameters) $(V2 $(GLINK FunctionAttributes)$(OPT))
+        $(B function) $(GLINK Parameters) $(V2 $(GLINK FunctionAttributes)$(OPT))
+)
+Declarator_production = $(GRAMMAR
+$(GNAME Declarator):
+        $(GLINK BasicType2)$(OPT) $(I Declarator) $(GLINK DeclaratorSuffixes)$(OPT)
+        $(GLINK BasicType2)$(OPT) $(I Identifier) $(GLINK DeclaratorSuffixes)$(OPT)
+)
+DeclaratorSuffixes_production = $(GRAMMAR
+$(GNAME DeclaratorSuffixes):
+        $(GLINK DeclaratorSuffix)
+        $(GLINK DeclaratorSuffix) $(I DeclaratorSuffixes)
+)
+DeclaratorSuffix_production = $(GRAMMAR
+$(GNAME DeclaratorSuffix):
+        $(B [ ])
+        $(B [) $(VEXPRESSION) $(B ])
+        $(B [) $(I Type) $(B ])
+	$(LINK2 template.html#TemplateParameterList, $(I TemplateParameterList))$(OPT) $(GLINK Parameters) $(V2 $(GLINK MemberFunctionAttributes)<sub>opt</sub>)
+)
+IdentifierList_production = $(GRAMMAR
+$(GNAME IdentifierList):
+        $(I Identifier)
+        $(I Identifier) $(B .) $(I IdentifierList)
+        $(I TemplateInstance)
+        $(I TemplateInstance) $(B .) $(I IdentifierList)
+)
+StorageClasses_production = $(GRAMMAR
+$(GNAME StorageClasses):
+	$(GLINK StorageClass)
+	$(GLINK StorageClass) $(I StorageClasses)
+)
+StorageClass_production = $(GRAMMAR
+$(GNAME StorageClass):
+        $(B abstract)
+        $(B auto)
+        $(B const)
+        $(B deprecated)
+        $(B extern)
+        $(B final)
+$(V2
+         $(B immutable)
+        $(B inout)
+        $(B shared)
+	$(B nothrow)
+        $(B override)
+	$(B pure)
+)        $(B scope)
+        $(B static)
+        $(B synchronized)
+)
+Type_production = $(GRAMMAR
+$(GNAME Type):
+        $(GLINK BasicType)
+        $(GLINK BasicType) $(GLINK Declarator2)
+)
+Declarator2_production = $(GRAMMAR
+$(GNAME Declarator2):
+        $(GLINK BasicType2) $(I Declarator2)
+        $(B $(LPAREN)) $(I Declarator2) $(B $(RPAREN))
+        $(B $(LPAREN)) $(I Declarator2) $(B $(RPAREN)) $(GLINK DeclaratorSuffixes)
+)
+Parameters_production = $(GRAMMAR
+$(GNAME Parameters):
+	$(B $(LPAREN)) $(GLINK ParameterList) $(B $(RPAREN))
+	$(B ( ))
+)
+ParameterList_production = $(GRAMMAR
+$(GNAME ParameterList):
+        $(GLINK Parameter)
+        $(GLINK Parameter) $(B ,) $(I ParameterList)
+        $(GLINK Parameter) $(B ...)
+        $(B ...)
+)
+Parameter_production = $(GRAMMAR
+$(GNAME Parameter):
+        $(GLINK Declarator)
+        $(GLINK Declarator) = $(I DefaultInitializerExpression)
+        $(I InOut) $(GLINK Declarator)
+        $(I InOut) $(GLINK Declarator) = $(I DefaultInitializerExpression)
+)
+InOut_production = $(GRAMMAR
+$(GNAME InOut):
+        $(B in)
+        $(B out)
+        $(B ref)
+        $(B lazy)
+)
+FunctionAttributes_production = $(GRAMMAR
+$(GNAME FunctionAttributes):
+	$(GLINK FunctionAttribute)
+	$(GLINK FunctionAttribute) $(I FunctionAttributes)
+)
+FunctionAttribute_production = $(GRAMMAR
+$(GNAME FunctionAttribute):
+	$(B nothrow)
+	$(B pure)
+)
+MemberFunctionAttributes_production = $(GRAMMAR
+$(GNAME MemberFunctionAttributes):
+	$(GLINK MemberFunctionAttribute)
+	$(GLINK MemberFunctionAttribute) $(I MemberFunctionAttributes)
+)
+MemberFunctionAttribute_production = $(GRAMMAR
+$(GNAME MemberFunctionAttribute):
+	$(B const)
+	$(B immutable)
+	$(B inout)
+	$(B shared)
+	$(GLINK FunctionAttribute)
+)
+DefaultInitializerExpression_production = $(GRAMMAR
+$(GNAME DefaultInitializerExpression):
+	$(ASSIGNEXPRESSION)
+$(V2	$(B __FILE__)
+	$(B __LINE__))
+)
+Initializer_production = $(GRAMMAR
+$(GNAME Initializer):
+        $(GLINK VoidInitializer)
+	$(GLINK NonVoidInitializer)
+)
+NonVoidInitializer_production = $(GRAMMAR
+$(GNAME NonVoidInitializer):
+        $(ASSIGNEXPRESSION)
+        $(GLINK ArrayInitializer)
+        $(GLINK StructInitializer)
+)
+ArrayInitializer_production = $(GRAMMAR
+$(GNAME ArrayInitializer):
+	$(B [ ])
+	$(B [) $(GLINK ArrayMemberInitializations) $(B ])
+)
+ArrayMemberInitializations_production = $(GRAMMAR
+$(GNAME ArrayMemberInitializations):
+	$(GLINK ArrayMemberInitialization)
+	$(GLINK ArrayMemberInitialization) $(B ,)
+	$(GLINK ArrayMemberInitialization) $(B ,) $(I ArrayMemberInitializations)
+)
+ArrayMemberInitialization_production = $(GRAMMAR
+$(GNAME ArrayMemberInitialization):
+	$(GLINK NonVoidInitializer)
+	$(ASSIGNEXPRESSION) $(B :) $(GLINK NonVoidInitializer)
+)
+StructInitializer_production = $(GRAMMAR
+$(GNAME StructInitializer):
+	$(B {  })
+	$(B {) $(GLINK StructMemberInitializers) $(B })
+)
+StructMemberInitializers_production = $(GRAMMAR
+$(GNAME StructMemberInitializers):
+	$(GLINK StructMemberInitializer)
+	$(GLINK StructMemberInitializer) $(B ,)
+	$(GLINK StructMemberInitializer) $(B ,) $(I StructMemberInitializers)
+)
+StructMemberInitializer_production = $(GRAMMAR
+$(GNAME StructMemberInitializer):
+	$(GLINK NonVoidInitializer)
+	$(I Identifier) $(B :) $(GLINK NonVoidInitializer)
+)
+AutoDeclaration_production = $(GRAMMAR
+$(GNAME AutoDeclaration):
+	$(I StorageClasses) $(I Identifier) $(B =) $(ASSIGNEXPRESSION) $(B ;)
+)
+Typeof_production = $(GRAMMAR
+$(GNAME Typeof):
+        $(B typeof $(LPAREN)) $(EXPRESSION) $(B $(RPAREN))
+        $(B typeof $(LPAREN)) $(B return) $(B $(RPAREN))
+)
+VoidInitializer_production = $(GRAMMAR
+$(GNAME VoidInitializer):
+	$(B void)
+)
+EnumDeclaration_production = $(GRAMMAR
+$(GNAME EnumDeclaration):
+	$(B enum) $(I EnumTag) $(I EnumBody)
+	$(B enum) $(I EnumBody)
+	$(B enum) $(I EnumTag) $(B :) $(I EnumBaseType) $(I EnumBody)
+	$(B enum) $(B :) $(I EnumBaseType) $(I EnumBody)
+)
+EnumTag_production = $(GRAMMAR
+$(GNAME EnumTag):
+	$(I Identifier)
+)
+EnumBaseType_production = $(GRAMMAR
+$(GNAME EnumBaseType):
+	$(I Type)
+)
+EnumBody_production = $(GRAMMAR
+$(GNAME EnumBody):
+	$(B ;)
+	$(B {) $(I EnumMembers) $(B })
+)
+EnumMembers_production = $(GRAMMAR
+$(GNAME EnumMembers):
+	$(I EnumMember)
+	$(I EnumMember) $(B ,)
+	$(I EnumMember) $(B ,) $(I EnumMembers)
+)
+EnumMember_production = $(GRAMMAR
+$(GNAME EnumMember):
+	$(I Identifier)
+	$(I Identifier) $(B =) $(ASSIGNEXPRESSION)
+$(V2
+	$(I Type) $(I Identifier) $(B =) $(ASSIGNEXPRESSION))
+)
+Expression_production = $(GRAMMAR
+$(GNAME Expression):
+	$(GLINK AssignExpression)
+	$(GLINK AssignExpression) $(B ,) $(I Expression)
+)
+AssignExpression_production = $(GRAMMAR
+$(GNAME AssignExpression):
+	$(GLINK ConditionalExpression)
+	$(GLINK ConditionalExpression) $(B =) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B +=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B -=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B *=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B /=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B %=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B &=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B |=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B ^=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B ~=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B &lt;&lt;=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B &gt;&gt;=) $(I AssignExpression)
+	$(GLINK ConditionalExpression) $(B &gt;&gt;&gt;=) $(I AssignExpression)
+$(V2
+	$(GLINK ConditionalExpression) $(B ^^=) $(I AssignExpression))
+)
+ConditionalExpression_production = $(GRAMMAR
+$(GNAME ConditionalExpression):
+	$(GLINK OrOrExpression)
+	$(GLINK OrOrExpression) $(B ?) $(GLINK Expression) $(B :) $(I ConditionalExpression)
+)
+OrOrExpression_production = $(GRAMMAR
+$(GNAME OrOrExpression):
+	$(GLINK AndAndExpression)
+	$(I OrOrExpression) $(B ||) $(GLINK AndAndExpression)
+)
+AndAndExpression_production = $(GRAMMAR
+$(GNAME AndAndExpression):
+	$(GLINK OrExpression)
+	$(I AndAndExpression) $(B &&) $(GLINK OrExpression)
+
+)
+OrExpression_production = $(GRAMMAR
+$(GNAME OrExpression):
+	$(GLINK XorExpression)
+	$(I OrExpression) $(B |) $(GLINK XorExpression)
+)
+XorExpression_production = $(GRAMMAR
+$(GNAME XorExpression):
+	$(GLINK AndExpression)
+	$(I XorExpression) $(B ^) $(GLINK AndExpression)
+)
+AndExpression_production = $(GRAMMAR
+$(GNAME AndExpression):
+	$(GLINK CmpExpression)
+	$(I AndExpression) $(B &) $(GLINK CmpExpression)
+)
+CmpExpression_production = $(GRAMMAR
+$(GNAME CmpExpression):
+	$(GLINK ShiftExpression)
+	$(GLINK EqualExpression)
+	$(GLINK IdentityExpression)
+	$(GLINK RelExpression)
+	$(GLINK InExpression)
+)
+EqualExpression_production = $(GRAMMAR
+$(GNAME EqualExpression):
+	$(GLINK ShiftExpression) $(B ==) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !=) $(GLINK ShiftExpression)
+)
+IdentityExpression_production = $(GRAMMAR
+$(GNAME IdentityExpression):
+	$(GLINK ShiftExpression) $(B is) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !is) $(GLINK ShiftExpression)
+)
+RelExpression_production = $(GRAMMAR
+$(GNAME RelExpression):
+	$(GLINK ShiftExpression) $(B &lt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B &lt;=) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B &gt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B &gt;=) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&lt;&gt;=) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&lt;&gt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B &lt;&gt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B &lt;&gt;=) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&gt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&gt;=) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&lt;) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !&lt;=) $(GLINK ShiftExpression)
+)
+InExpression_production = $(GRAMMAR
+$(GNAME InExpression):
+	$(GLINK ShiftExpression) $(B in) $(GLINK ShiftExpression)
+	$(GLINK ShiftExpression) $(B !in) $(GLINK ShiftExpression)
+)
+ShiftExpression_production = $(GRAMMAR
+$(GNAME ShiftExpression):
+	$(GLINK AddExpression)
+	$(I ShiftExpression) $(B &lt;&lt;) $(GLINK AddExpression)
+	$(I ShiftExpression) $(B &gt;&gt;) $(GLINK AddExpression)
+	$(I ShiftExpression) $(B &gt;&gt;&gt;) $(GLINK AddExpression)
+)
+AddExpression_production = $(GRAMMAR
+$(GNAME AddExpression):
+	$(GLINK MulExpression)
+	$(I AddExpression) $(B +) $(GLINK MulExpression)
+	$(I AddExpression) $(B -) $(GLINK MulExpression)
+	$(GLINK CatExpression)
+)
+CatExpression_production = $(GRAMMAR
+$(GNAME CatExpression):
+	$(I AddExpression) $(B ~) $(GLINK MulExpression)
+)
+MulExpression_production = $(V1 $(GRAMMAR
+$(GNAME MulExpression):
+	$(GLINK UnaryExpression)
+	$(I MulExpression) $(B *) $(GLINK UnaryExpression)
+	$(I MulExpression) $(B /) $(GLINK UnaryExpression)
+	$(I MulExpression) $(B %) $(GLINK UnaryExpression)
+))
+$(V2 $(GRAMMAR
+	$(GNAME MulExpression):
+	$(GLINK PowExpression)
+	$(I MulExpression) $(B *) $(GLINK PowExpression)
+	$(I MulExpression) $(B /) $(GLINK PowExpression)
+	$(I MulExpression) $(B %) $(GLINK PowExpression)
+))
+PowExpression_production = $(GRAMMAR
+$(GNAME PowExpression):
+	$(GLINK UnaryExpression)
+	$(GLINK UnaryExpression) ^^ $(I PowExpression)
+)
+UnaryExpression_production = $(GRAMMAR
+$(GNAME UnaryExpression):
+	$(GLINK PostfixExpression)
+	$(B &amp;) $(I UnaryExpression)
+	$(B ++) $(I UnaryExpression)
+	$(B --) $(I UnaryExpression)
+	$(B *) $(I UnaryExpression)
+	$(B -) $(I UnaryExpression)
+	$(B +) $(I UnaryExpression)
+	$(B !) $(I UnaryExpression)
+	$(B ~) $(I UnaryExpression)
+	$(B $(LPAREN)) $(I Type) $(B $(RPAREN) .) $(I Identifier)
+	$(GLINK NewExpression)
+	$(GLINK DeleteExpression)
+	$(GLINK CastExpression)
+	$(LINK2 class.html#anonymous, $(I NewAnonClassExpression))
+)
+NewExpression_production = $(GRAMMAR
+$(GNAME NewExpression):
+	$(I NewArguments) $(I Type) $(B [) $(GLINK AssignExpression) $(B ])
+	$(I NewArguments) $(I Type) $(B $(LPAREN)) $(GLINK ArgumentList) $(B $(RPAREN))
+	$(I NewArguments) $(I Type)
+	$(I NewArguments) $(I ClassArguments) $(I BaseClasslist)<sub>opt</sub> $(B {) $(I DeclDefs) $(B } )
+)
+NewArguments_production = $(GRAMMAR
+$(GNAME NewArguments):
+	$(B new $(LPAREN)) $(GLINK ArgumentList) $(B $(RPAREN))
+	$(B new ( ))
+	$(B new)
+)
+ClassArguments_production = $(GRAMMAR
+$(GNAME ClassArguments):
+	$(B class $(LPAREN)) $(GLINK ArgumentList) $(B $(RPAREN))
+	$(B class ( ))
+	$(B class)
+)
+ArgumentList_production = $(GRAMMAR
+$(GNAME ArgumentList):
+	$(GLINK AssignExpression)
+	$(GLINK AssignExpression) $(B ,) $(I ArgumentList)
+)
+DeleteExpression_production = $(GRAMMAR
+$(GNAME DeleteExpression):
+	$(B delete) $(GLINK UnaryExpression)
+)
+CastExpression_production = $(GRAMMAR
+$(GNAME CastExpression):
+	$(B cast $(LPAREN)) $(I Type) $(B $(RPAREN)) $(GLINK UnaryExpression)
+)
+PostfixExpression_production = $(GRAMMAR
+$(GNAME PostfixExpression):
+	$(GLINK PrimaryExpression)
+	$(I PostfixExpression) $(B .) $(I Identifier)
+	$(I PostfixExpression) $(B .) $(GLINK NewExpression)
+	$(I PostfixExpression) $(B ++)
+	$(I PostfixExpression) $(B --)
+	$(I PostfixExpression) $(B ( ))
+	$(I PostfixExpression) $(B $(LPAREN)) $(GLINK ArgumentList) $(B $(RPAREN))
+	$(GLINK IndexExpression)
+	$(GLINK SliceExpression)
+)
+IndexExpression_production = $(GRAMMAR
+$(GNAME IndexExpression):
+	$(GLINK PostfixExpression) $(B [) $(GLINK ArgumentList) $(B ])
+)
+SliceExpression_production = $(GRAMMAR
+$(GNAME SliceExpression):
+	$(GLINK PostfixExpression) $(B [ ])
+	$(GLINK PostfixExpression) $(B [) $(GLINK AssignExpression) $(B ..) $(GLINK AssignExpression) $(B ])
+)
+PrimaryExpression_production = $(GRAMMAR
+$(GNAME PrimaryExpression):
+	$(I Identifier)
+	$(B .)$(I Identifier)
+	$(LINK2 template.html#TemplateInstance, $(I TemplateInstance))
+	$(LINK2 #this, $(B this))
+	$(LINK2 #super, $(B super))
+	$(LINK2 #null, $(B null))
+	$(B true)
+	$(B false)
+	$(B $)
+$(V2
+	$(B __FILE__)
+	$(B __LINE__))
+	$(GLINK2 lex, IntegerLiteral)
+	$(GLINK2 lex, FloatLiteral)
+	$(GLINK CharacterLiteral)
+	$(GLINK StringLiterals)
+	$(GLINK ArrayLiteral)
+	$(GLINK AssocArrayLiteral)
+	$(GLINK FunctionLiteral)
+	$(GLINK AssertExpression)
+	$(GLINK MixinExpression)
+	$(GLINK ImportExpression)
+	$(I BasicType) $(B .) $(I Identifier)
+	$(LINK2 declaration.html#Typeof, $(I Typeof))
+	$(GLINK TypeidExpression)
+	$(GLINK IsExpression)
+	$(B $(LPAREN)) $(I Expression) $(B $(RPAREN))
+$(V2
+	$(LINK2 traits.html#TraitsExpression, $(I TraitsExpression)))
+)
+StringLiterals_production = $(GRAMMAR
+$(GNAME StringLiterals):
+	$(LINK2 lex.html#StringLiteral, $(I StringLiteral))
+	$(I StringLiterals) $(LINK2 lex.html#StringLiteral, $(I StringLiteral))
+)
+ArrayLiteral_production = $(GRAMMAR
+$(GNAME ArrayLiteral):
+	$(B [) $(GLINK ArgumentList) $(B ])
+)
+AssocArrayLiteral_production = $(GRAMMAR
+$(GNAME AssocArrayLiteral):
+	$(B [) $(I KeyValuePairs) $(B ])
+)
+KeyValuePairs_production = $(GRAMMAR
+$(GNAME KeyValuePairs):
+	$(I KeyValuePair)
+	$(I KeyValuePair) $(B ,) $(I KeyValuePairs)
+)
+KeyValuePair_production = $(GRAMMAR
+$(GNAME KeyValuePair):
+	$(I KeyExpression) $(B :) $(I ValueExpression)
+)
+KeyExpression_production = $(GRAMMAR
+$(GNAME KeyExpression):
+	$(GLINK ConditionalExpression)
+)
+ValueExpression_production = $(GRAMMAR
+$(GNAME ValueExpression):
+	$(GLINK ConditionalExpression)
+)
+FunctionLiteral_production = $(GRAMMAR
+$(GNAME FunctionLiteral):
+	$(B function) $(I Type)<sub>opt</sub> $(I ParameterAttributes) <sub>opt</sub> $(I FunctionBody)
+	$(B delegate) $(I Type)<sub>opt</sub> $(I ParameterAttributes) <sub>opt</sub> $(I FunctionBody)
+	$(I ParameterAttributes) $(I FunctionBody)
+	$(I FunctionBody)
+)
+ParameterAttributes_production = $(GRAMMAR
+$(GNAME ParameterAttributes):
+	$(LINK2 declaration.html#Parameters, $(I Parameters))
+$(V2
+	$(LINK2 declaration.html#Parameters, $(I Parameters)) $(LINK2 declaration.html#FunctionAttributes, $(I FunctionAttributes))
+)
+)
+AssertExpression_production = $(GRAMMAR
+$(GNAME AssertExpression):
+	$(B assert $(LPAREN)) $(GLINK AssignExpression) $(B $(RPAREN))
+	$(B assert $(LPAREN)) $(GLINK AssignExpression) $(B ,) $(GLINK AssignExpression) $(B $(RPAREN))
+)
+MixinExpression_production = $(GRAMMAR
+$(GNAME MixinExpression):
+	$(B mixin $(LPAREN)) $(GLINK AssignExpression) $(B $(RPAREN))
+)
+ImportExpression_production = $(GRAMMAR
+$(GNAME ImportExpression):
+	$(B import $(LPAREN)) $(GLINK AssignExpression) $(B $(RPAREN))
+)
+TypeidExpression_production = $(GRAMMAR
+$(GNAME TypeidExpression):
+    $(B typeid $(LPAREN)) $(I Type) $(B $(RPAREN))
+$(V2      $(B typeid $(LPAREN)) $(I Expression) $(B $(RPAREN)))
+)
+IsExpression_production = $(GRAMMAR
+$(GNAME IsExpression):
+	$(B is $(LPAREN)) $(I Type) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(B :) $(I TypeSpecialization) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(B ==) $(I TypeSpecialization) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(I Identifier) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(I Identifier) $(B :) $(I TypeSpecialization) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(I Identifier) $(B ==) $(I TypeSpecialization) $(B $(RPAREN))
+	$(V2 $(B is $(LPAREN)) $(I Type) $(I Identifier) $(B :) $(I TypeSpecialization) $(B ,) $(I TemplateParameterList) $(B $(RPAREN))
+	$(B is $(LPAREN)) $(I Type) $(I Identifier) $(B ==) $(I TypeSpecialization) $(B ,) $(I TemplateParameterList) $(B $(RPAREN))
+)
+)
+TypeSpecialization_production = $(GRAMMAR
+$(GNAME TypeSpecialization):
+	$(I Type)
+$(V1	$(B typedef)
+)	$(B struct)
+	$(B union)
+	$(B class)
+	$(B interface)
+	$(B enum)
+	$(B function)
+	$(B delegate)
+	$(B super)
+$(V2
+	$(B const)
+	$(B immutable)
+	$(B inout)
+	$(B shared)
+	$(B return)
+))
+FunctionBody_production = $(GRAMMAR
+$(GNAME FunctionBody):
+	$(LINK2 statement.html#BlockStatement, $(I BlockStatement))
+	$(I BodyStatement)
+	$(I InStatement) $(I BodyStatement)
+	$(I OutStatement) $(I BodyStatement)
+	$(I InStatement) $(I OutStatement) $(I BodyStatement)
+	$(I OutStatement) $(I InStatement) $(I BodyStatement)
+)
+InStatement_production = $(GRAMMAR
+$(GNAME InStatement):
+	$(B in) $(LINK2 statement.html#BlockStatement, $(I BlockStatement))
+)
+OutStatement_production = $(GRAMMAR
+$(GNAME OutStatement):
+	$(B out) $(LINK2 statement.html#BlockStatement, $(I BlockStatement))
+	$(B out) $(B $(LPAREN)) $(I Identifier) $(B $(RPAREN)) $(LINK2 statement.html#BlockStatement, $(I BlockStatement))
+)
+BodyStatement_production = $(GRAMMAR
+$(GNAME BodyStatement):
+	$(B body) $(LINK2 statement.html#BlockStatement, $(I BlockStatement))
+)
+InterfaceDeclaration_production = $(GRAMMAR
+$(GNAME InterfaceDeclaration):
+	$(B interface) $(I Identifier) $(BaseInterfaceList) $(I InterfaceBody)
+	$(LINK2 template.html#InterfaceTemplateDeclaration, $(I InterfaceTemplateDeclaration))
+)
+BaseInterfaceList_production = $(GRAMMAR
+$(GNAME BaseInterfaceList):
+	$(I Empty)
+	$(B :) $(LINK2 class.html#InterfaceClasses, $(I InterfaceClasses))
+)
+InterfaceBody_production = $(GRAMMAR
+$(GNAME InterfaceBody):
+	$(B {) DeclDefs $(B })
+)
+Module_production = $(GRAMMAR
+$(GNAME Module):
+	$(GLINK ModuleDeclaration) $(GLINK DeclDefs)
+	$(GLINK DeclDefs)
+)
+DeclDefs_production = $(GRAMMAR
+$(GNAME DeclDefs):
+	$(I DeclDef)
+	$(I DeclDef) $(I DeclDefs)
+)
+DeclDef_production = $(GRAMMAR
+$(GNAME DeclDef):
+	$(LINK2 attribute.html#AttributeSpecifier, $(I AttributeSpecifier))
+	$(GLINK ImportDeclaration)
+	$(I EnumDeclaration)
+	$(I ClassDeclaration)
+	$(I InterfaceDeclaration)
+	$(I AggregateDeclaration)
+	$(I Declaration)
+	$(I Constructor)
+	$(I Destructor)
+	$(I Invariant)
+	$(I UnitTest)
+	$(I StaticConstructor)
+	$(I StaticDestructor)
+$(V2
+	$(I SharedStaticConstructor)
+	$(I SharedStaticDestructor)
+)	$(LINK2 version.html#ConditionalDeclaration, $(I ConditionalDeclaration))
+	$(LINK2 version.html#StaticAssert, $(I StaticAssert))
+	$(LINK2 template.html#TemplateDeclaration, $(I TemplateDeclaration))
+	$(LINK2 template-mixin.html#TemplateMixin, $(I TemplateMixin))
+	$(GLINK MixinDeclaration)
+	$(B ;)
+)
+ModuleDeclaration_production = $(GRAMMAR
+$(GNAME ModuleDeclaration):
+	$(B module) $(I ModuleFullyQualifiedName) $(B ;)
+)
+ModuleFullyQualifiedName_production = $(GRAMMAR
+$(GNAME ModuleFullyQualifiedName):
+	$(I ModuleName)
+	$(I Packages) $(B .) $(I ModuleName)
+)
+ModuleName_production = $(GRAMMAR
+$(GNAME ModuleName):
+	$(I Identifier)
+)
+Packages_production = $(GRAMMAR
+$(GNAME Packages):
+	$(I PackageName)
+	$(I Packages) $(B .) $(I PackageName)
+)
+PackageName_production = $(GRAMMAR
+$(GNAME PackageName):
+	$(I Identifier)
+)
+ImportDeclaration_production = $(GRAMMAR
+$(GNAME ImportDeclaration):
+	$(B import) $(I ImportList) $(B ;)
+	$(B static import) $(I ImportList) $(B ;)
+)
+ImportList_production = $(GRAMMAR
+$(GNAME ImportList):
+	$(I Import)
+	$(I ImportBindings)
+	$(I Import) $(B ,) $(I ImportList)
+)
+Import_production = $(GRAMMAR
+$(GNAME Import):
+	$(I ModuleFullyQualifiedName)
+	$(I ModuleAliasIdentifier) $(B =) $(I ModuleFullyQualifiedName)
+)
+ImportBindings_production = $(GRAMMAR
+$(GNAME ImportBindings):
+	$(I Import) $(B :) $(I ImportBindList)
+)
+ImportBindList_production = $(GRAMMAR
+$(GNAME ImportBindList):
+	$(I ImportBind)
+	$(I ImportBind) $(B ,) $(I ImportBindList)
+)
+ImportBind_production = $(GRAMMAR
+$(GNAME ImportBind):
+	$(I Identifier)
+	$(I Identifier) = $(I Identifier)
+)
+ModuleAliasIdentifier_production = $(GRAMMAR
+$(GNAME ModuleAliasIdentifier):
+	$(I Identifier)
+)
+MixinDeclaration_production = $(GRAMMAR
+$(GNAME MixinDeclaration):
+    $(B mixin) $(B $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN)) $(B ;)
+)
+Statement_production = $(GRAMMAR
+$(GNAME Statement):
+    $(B ;)
+    $(GLINK NonEmptyStatement)
+    $(GLINK ScopeBlockStatement)
+)
+NoScopeNonEmptyStatement_production = $(GRAMMAR
+$(GNAME NoScopeNonEmptyStatement):
+    $(GLINK NonEmptyStatement)
+    $(GLINK BlockStatement)
+)
+NoScopeStatement_production = $(GRAMMAR
+$(GNAME NoScopeStatement):
+    $(B ;)
+    $(GLINK NonEmptyStatement)
+    $(GLINK BlockStatement)
+)
+NonEmptyOrScopeBlockStatement_production = $(GRAMMAR
+$(GNAME NonEmptyOrScopeBlockStatement):
+    $(GLINK NonEmptyStatement)
+    $(GLINK ScopeBlockStatement)
+)
+NonEmptyStatement_production = $(GRAMMAR
+$(GNAME NonEmptyStatement):
+    $(GLINK LabeledStatement)
+    $(GLINK ExpressionStatement)
+    $(GLINK DeclarationStatement)
+    $(GLINK IfStatement)
+    $(GLINK WhileStatement)
+    $(GLINK DoStatement)
+    $(GLINK ForStatement)
+    $(GLINK ForeachStatement)
+    $(GLINK SwitchStatement)
+$(V2      $(GLINK FinalSwitchStatement)
+)    $(GLINK CaseStatement)
+$(V2      $(GLINK CaseRangeStatement)
+)    $(GLINK DefaultStatement)
+    $(GLINK ContinueStatement)
+    $(GLINK BreakStatement)
+    $(GLINK ReturnStatement)
+    $(GLINK GotoStatement)
+    $(GLINK WithStatement)
+    $(GLINK SynchronizedStatement)
+    $(GLINK TryStatement)
+    $(GLINK ScopeGuardStatement)
+    $(GLINK ThrowStatement)
+$(V1    $(GLINK VolatileStatement)
+)    $(GLINK AsmStatement)
+    $(GLINK PragmaStatement)
+    $(GLINK MixinStatement)
+$(V2      $(GLINK ForeachRangeStatement))
+    $(LINK2 version.html#ConditionalStatement, $(I ConditionalStatement))
+    $(LINK2 version.html#StaticAssert, $(I StaticAssert))
+    $(LINK2 template-mixin.html#TemplateMixin, $(I TemplateMixin))
+)
+ScopeStatement_production = $(GRAMMAR
+$(I ScopeStatement):
+    $(GLINK NonEmptyStatement)
+    $(GLINK BlockStatement)
+)
+ScopeBlockStatement_production = $(GRAMMAR
+$(I ScopeBlockStatement):
+    $(GLINK BlockStatement)
+)
+LabeledStatement_production = $(GRAMMAR
+$(I LabeledStatement):
+    $(I Identifier) : $(PSSEMI)
+)
+BlockStatement_production = $(GRAMMAR
+$(I BlockStatement):
+    $(B { })
+    $(B {) $(I StatementList) $(B })
+)
+StatementList_production = $(GRAMMAR
+$(GNAME StatementList):
+    $(PSSEMI_PSCURLYSCOPE)
+    $(PSSEMI_PSCURLYSCOPE) $(I StatementList)
+)
+ExpressionStatement_production = $(GRAMMAR
+$(I ExpressionStatement):
+    $(EXPRESSION) $(B ;)
+)
+DeclarationStatement_production = $(GRAMMAR
+$(I DeclarationStatement):
+    $(I Declaration)
+)
+IfStatement_production = $(GRAMMAR
+$(I IfStatement):
+	$(B if $(LPAREN)) $(I IfCondition) $(B $(RPAREN)) $(I ThenStatement)
+	$(B if $(LPAREN)) $(I IfCondition) $(B $(RPAREN)) $(I ThenStatement) $(B else) $(I ElseStatement)
+)
+IfCondition_production = $(GRAMMAR
+$(GNAME IfCondition):
+	$(EXPRESSION)
+	$(B auto) $(I Identifier) $(B =) $(EXPRESSION)
+	$(I Declarator) $(B =) $(EXPRESSION)
+)
+ThenStatement_production = $(GRAMMAR
+$(GNAME ThenStatement):
+	$(PSSCOPE)
+)
+ElseStatement_production = $(GRAMMAR
+$(GNAME ElseStatement):
+	$(PSSCOPE)
+)
+WhileStatement_production = $(GRAMMAR
+$(I WhileStatement):
+    $(B while $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+)
+DoStatement_production = $(GRAMMAR
+$(I DoStatement):
+    $(B do) $(PSSCOPE) $(B  while $(LPAREN)) $(EXPRESSION) $(B $(RPAREN))
+)
+ForStatement_production = $(GRAMMAR
+$(I ForStatement):
+	$(B for $(LPAREN))$(I Initialize) $(I Test) $(B ;) $(I Increment)$(B $(RPAREN)) $(PSSCOPE)
+)
+Initialize_production = $(GRAMMAR
+$(GNAME Initialize):
+	$(B ;)
+	$(PS0)
+)
+Test_production = $(GRAMMAR
+$(GNAME Test):
+	$(I empty)
+	$(EXPRESSION)
+)
+Increment_production = $(GRAMMAR
+$(GNAME Increment):
+	$(I empty)
+	$(EXPRESSION)
+)
+ForeachStatement_production = $(GRAMMAR
+$(I ForeachStatement):
+    $(I Foreach) $(B $(LPAREN))$(I ForeachTypeList) $(B ;) $(I Aggregate)$(B $(RPAREN)) $(PS0)
+)
+Foreach_production = $(GRAMMAR
+$(GNAME Foreach):
+    $(B foreach)
+    $(B foreach_reverse)
+)
+ForeachTypeList_production = $(GRAMMAR
+$(GNAME ForeachTypeList):
+    $(I ForeachType)
+    $(I ForeachType) , $(I ForeachTypeList)
+)
+ForeachType_production = $(GRAMMAR
+$(GNAME ForeachType):
+    $(B ref) $(I Type) $(I Identifier)
+    $(I Type) $(I Identifier)
+    $(B ref) $(I Identifier)
+    $(I Identifier)
+)
+Aggregate_production = $(GRAMMAR
+$(GNAME Aggregate):
+    $(EXPRESSION)
+)
+SwitchStatement_production = $(GRAMMAR
+$(I SwitchStatement):
+	$(B switch $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+)
+CaseStatement_production = $(GRAMMAR
+$(GNAME CaseStatement):
+	$(B case) $(LINK2 expression.html#ArgumentList, $(I ArgumentList)) $(B :) $(PSSEMI_PSCURLYSCOPE)
+)
+CaseRangeStatement_production = $(GRAMMAR
+$(GNAME CaseRangeStatement):
+	$(B case) $(I FirstExp) $(B : .. case) $(I LastExp) $(B :) $(PSSEMI_PSCURLYSCOPE)
+)
+FirstExp_production = $(GRAMMAR
+$(I FirstExp):
+	$(I AssignExpression)
+)
+LastExp_production = $(GRAMMAR
+$(I LastExp):
+	$(I AssignExpression)
+)
+DefaultStatement_production = $(GRAMMAR
+$(GNAME DefaultStatement):
+	$(B default :) $(PSSEMI_PSCURLYSCOPE)
+)
+FinalSwitchStatement_production = $(GRAMMAR
+$(I FinalSwitchStatement):
+	$(B final switch $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+)
+ContinueStatement_production = $(GRAMMAR
+$(I ContinueStatement):
+    $(B continue;)
+    $(B continue) $(I Identifier) $(B ;)
+)
+BreakStatement_production = $(GRAMMAR
+$(I BreakStatement):
+    $(B break;)
+    $(B break) $(I Identifier) $(B ;)
+)
+ReturnStatement_production = $(GRAMMAR
+$(I ReturnStatement):
+    $(B return;)
+    $(B return) $(EXPRESSION) $(B ;)
+)
+GotoStatement_production = $(GRAMMAR
+$(I GotoStatement):
+    $(B goto) $(I Identifier) $(B ;)
+    $(B goto) $(B default) $(B ;)
+    $(B goto) $(B case) $(B ;)
+    $(B goto) $(B case) $(EXPRESSION) $(B ;)
+)
+WithStatement_production = $(GRAMMAR
+$(I WithStatement):
+	$(B with) $(B $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+	$(B with) $(B $(LPAREN)) $(LINK2 template.html#Symbol, $(I Symbol)) $(B $(RPAREN)) $(PSSCOPE)
+	$(B with) $(B $(LPAREN)) $(LINK2 template.html#TemplateInstance, $(I TemplateInstance)) $(B $(RPAREN)) $(PSSCOPE)
+)
+SynchronizedStatement_production = $(GRAMMAR
+$(I SynchronizedStatement):
+    $(B synchronized) $(PSSCOPE)
+    $(B synchronized $(LPAREN)) $(EXPRESSION) $(B $(RPAREN)) $(PSSCOPE)
+)
+TryStatement_production = $(GRAMMAR
+$(I TryStatement):
+	$(B try) $(PSSCOPE) $(I Catches)
+	$(B try) $(PSSCOPE) $(I Catches) $(I FinallyStatement)
+	$(B try) $(PSSCOPE) $(I FinallyStatement)
+)
+Catches_production = $(GRAMMAR
+$(GNAME Catches):
+	$(I LastCatch)
+	$(I Catch)
+	$(I Catch) $(I Catches)
+)
+LastCatch_production = $(GRAMMAR
+$(GNAME LastCatch):
+	$(B catch) $(PS0)
+)
+Catch_production = $(GRAMMAR
+$(GNAME Catch):
+	$(B catch $(LPAREN)) $(I CatchParameter) $(B $(RPAREN)) $(PS0)
+)
+CatchParameter_production = $(GRAMMAR
+$(GNAME CatchParameter):
+	$(I BasicType) $(I Identifier)
+)
+FinallyStatement_production = $(GRAMMAR
+$(GNAME FinallyStatement):
+	$(B finally) $(PS0)
+)
+ThrowStatement_production = $(GRAMMAR
+$(I ThrowStatement):
+	$(B throw) $(EXPRESSION) $(B ;)
+)
+ScopeGuardStatement_production = $(GRAMMAR
+$(I ScopeGuardStatement):
+	$(B scope(exit)) $(PSCURLYSCOPE)
+	$(B scope(success)) $(PSCURLYSCOPE)
+	$(B scope(failure)) $(PSCURLYSCOPE)
+)
+VolatileStatement_production = $(GRAMMAR
+$(I VolatileStatement):
+	$(B volatile) $(PSSEMI_PSCURLYSCOPE)
+	$(B volatile) $(B ;)
+)
+AsmStatement_production = $(GRAMMAR
+$(GNAME AsmStatement):
+	$(B asm { })
+	$(B asm {) $(I AsmInstructionList) $(B })
+)
+AsmInstructionList_production = $(GRAMMAR
+$(GNAME AsmInstructionList):
+	$(I AsmInstruction) $(B ;)
+	$(I AsmInstruction) $(B ;) $(I AsmInstructionList)
+)
+PragmaStatement_production = $(GRAMMAR
+$(I PragmaStatement):
+    $(LINK2 pragma.html, $(I Pragma)) $(PSSEMI)
+)
+MixinStatement_production = $(GRAMMAR
+$(I MixinStatement):
+    $(B mixin) $(B $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN)) $(B ;)
+)
+ForeachRangeStatement_production = $(GRAMMAR
+$(I ForeachRangeStatement):
+    $(GLINK Foreach) $(LPAREN)$(GLINK ForeachType) $(B ;) $(I LwrExpression) $(B ..) $(I UprExpression) $(B $(RPAREN)) $(PSSCOPE)
+)
+LwrExpression_production = $(GRAMMAR
+$(GNAME LwrExpression):
+    $(EXPRESSION)
+)
+UprExpression_production = $(GRAMMAR
+$(GNAME UprExpression):
+    $(EXPRESSION)
+)
+AggregateDeclaration_production = $(GRAMMAR
+$(GNAME AggregateDeclaration):
+	$(B struct) $(I Identifier) $(I StructBody)
+	$(B union) $(I Identifier) $(I StructBody)
+	$(B struct) $(I Identifier) $(B ;)
+	$(B union) $(I Identifier) $(B ;)
+	$(LINK2 template.html#StructTemplateDeclaration, $(I StructTemplateDeclaration))
+	$(LINK2 template.html#UnionTemplateDeclaration, $(I UnionTemplateDeclaration))
+)
+StructBody_production = $(GRAMMAR
+$(GNAME StructBody):
+	$(B {) $(B })
+	$(B {) $(I StructBodyDeclarations) $(B })
+)
+StructBodyDeclarations_production = $(GRAMMAR
+$(GNAME StructBodyDeclarations):
+	$(I StructBodyDeclaration)
+	$(I StructBodyDeclaration) $(I StructBodyDeclarations)
+)
+StructBodyDeclaration_production = $(GRAMMAR
+$(GNAME StructBodyDeclaration):
+	$(I Declaration)
+	$(I StaticConstructor)
+	$(I StaticDestructor)
+	$(I Invariant)
+	$(I UnitTest)
+	$(I StructAllocator)
+	$(I StructDeallocator)
+	$(V2 $(GLINK StructConstructor)
+	$(GLINK StructPostblit)
+	$(GLINK StructDestructor))
+$(V2
+	$(LINK2 class.html#AliasThis, $(I AliasThis))
+)
+)
+StructAllocator_production = $(GRAMMAR
+$(GNAME StructAllocator):
+	$(I ClassAllocator)
+)
+StructDeallocator_production = $(GRAMMAR
+$(GNAME StructDeallocator):
+	$(I ClassDeallocator)
+)
+StructConstructor_production = $(GRAMMAR
+$(GNAME StructConstructor):
+    $(B this( $(I ParameterList) )) $(I FunctionBody)
+)
+StructPostblit_production = $(GRAMMAR
+$(GNAME StructPostblit):
+    $(B this(this)) $(I FunctionBody)
+)
+StructDestructor_production = $(GRAMMAR
+$(GNAME StructDestructor):
+    $(B ~this()) $(I FunctionBody)
+)
+TemplateDeclaration_production = $(GRAMMAR
+$(GNAME TemplateDeclaration):
+	$(B template) $(GLINK TemplateIdentifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt)))
+		$(B {) DeclDefs $(B })
+)
+TemplateIdentifier_production = $(GRAMMAR
+$(GNAME TemplateIdentifier):
+	$(I Identifier)
+)
+TemplateParameterList_production = $(GRAMMAR
+$(GNAME TemplateParameterList):
+	$(I TemplateParameter)
+	$(I TemplateParameter) , $(I TemplateParameterList)
+)
+TemplateParameter_production = $(GRAMMAR
+$(GNAME TemplateParameter):
+	$(GLINK TemplateTypeParameter)
+	$(GLINK TemplateValueParameter)
+	$(GLINK TemplateAliasParameter)
+	$(GLINK TemplateTupleParameter)
+$(V2
+	$(GLINK TemplateThisParameter))
+)
+TemplateInstance_production = $(GRAMMAR
+$(GNAME TemplateInstance):
+	$(GLINK TemplateIdentifier) $(B !$(LPAREN)) $(GLINK TemplateArgumentList) $(B $(RPAREN))
+$(V2
+	$(GLINK TemplateIdentifier) $(B !) $(GLINK TemplateSingleArgument)
+)
+)
+TemplateArgumentList_production = $(GRAMMAR
+$(GNAME TemplateArgumentList):
+	$(GLINK TemplateArgument)
+	$(GLINK TemplateArgument) , $(I TemplateArgumentList)
+)
+TemplateArgument_production = $(GRAMMAR
+$(GNAME TemplateArgument):
+	$(I Type)
+	$(ASSIGNEXPRESSION)
+	$(I Symbol)
+)
+Symbol_production = $(GRAMMAR
+$(GNAME Symbol):
+	$(I SymbolTail)
+	$(B .) $(I SymbolTail)
+)
+SymbolTail_production = $(GRAMMAR
+$(GNAME SymbolTail):
+	$(I Identifier)
+	$(I Identifier) $(B .) $(I SymbolTail)
+	$(GLINK TemplateInstance)
+	$(GLINK TemplateInstance) $(B .) $(I SymbolTail)
+)
+TemplateSingleArgument_production = $(GRAMMAR
+$(GNAME TemplateSingleArgument):
+	$(I Identifier)
+	$(GLINK2 declaration, BasicTypeX)
+	$(GLINK2 lex, CharacterLiteral)
+	$(GLINK2 lex, StringLiteral)
+	$(GLINK2 lex, IntegerLiteral)
+	$(GLINK2 lex, FloatLiteral)
+	$(B true)
+	$(B false)
+	$(B null)
+	$(B __FILE__)
+	$(B __LINE__)
+
+)
+TemplateTypeParameter_production = $(GRAMMAR
+$(GNAME TemplateTypeParameter):
+	$(I Identifier)
+	$(I Identifier) $(I TemplateTypeParameterSpecialization)
+	$(I Identifier) $(I TemplateTypeParameterDefault)
+	$(I Identifier) $(I TemplateTypeParameterSpecialization) $(I TemplateTypeParameterDefault)
+)
+TemplateTypeParameterSpecialization_production = $(GRAMMAR
+$(GNAME TemplateTypeParameterSpecialization):
+	 $(B :) $(I Type)
+)
+TemplateTypeParameterDefault_production = $(GRAMMAR
+$(GNAME TemplateTypeParameterDefault):
+	 $(B =) $(I Type)
+)
+TemplateThisParameter_production = $(GRAMMAR
+$(GNAME TemplateThisParameter):
+	$(B this) $(I TemplateTypeParameter)
+)
+TemplateValueParameter_production = $(GRAMMAR
+$(GNAME TemplateValueParameter):
+    $(I Declaration)
+    $(I Declaration) $(I TemplateValueParameterSpecialization)
+    $(I Declaration) $(I TemplateValueParameterDefault)
+    $(I Declaration) $(I TemplateValueParameterSpecialization) $(I TemplateValueParameterDefault)
+)
+TemplateValueParameterSpecialization_production = $(GRAMMAR
+$(GNAME TemplateValueParameterSpecialization):
+    $(B :) $(LINK2 expression.html#ConditionalExpression, $(I ConditionalExpression))
+)
+TemplateValueParameterDefault_production = $(GRAMMAR
+$(GNAME TemplateValueParameterDefault):
+$(V2
+    $(B = __FILE__)
+    $(B = __LINE__))
+    $(B =) $(LINK2 expression.html#ConditionalExpression, $(I ConditionalExpression))
+)
+TemplateAliasParameter_production = $(GRAMMAR
+$(GNAME TemplateAliasParameter):
+    $(B alias) $(I Identifier) $(I TemplateAliasParameterSpecialization)$(SUB $(I opt)) $(I TemplateAliasParameterDefault)$(SUB $(I opt))
+)
+TemplateAliasParameterSpecialization_production = $(GRAMMAR
+$(GNAME TemplateAliasParameterSpecialization):
+     $(B :) $(I Type)
+)
+TemplateAliasParameterDefault_production = $(GRAMMAR
+$(GNAME TemplateAliasParameterDefault):
+     $(B =) $(I Type)
+)
+TemplateTupleParameter_production = $(GRAMMAR
+$(GNAME TemplateTupleParameter):
+	$(I Identifier) $(B ...)
+)
+ClassTemplateDeclaration_production = $(GRAMMAR
+$(GNAME ClassTemplateDeclaration):
+    $(B class) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(I BaseClassList) $(I ClassBody)
+)
+StructTemplateDeclaration_production = $(GRAMMAR
+$(GNAME StructTemplateDeclaration):
+    $(B struct) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 struct.html#StructBody, $(I StructBody))
+)
+UnionTemplateDeclaration_production = $(GRAMMAR
+$(GNAME UnionTemplateDeclaration):
+    $(B union) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 struct.html#StructBody, $(I StructBody))
+)
+InterfaceTemplateDeclaration_production = $(GRAMMAR
+$(GNAME InterfaceTemplateDeclaration):
+    $(B interface) $(I Identifier) $(B $(LPAREN)) $(GLINK TemplateParameterList) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt))) $(LINK2 interface.html#BaseInterfaceList, $(I BaseInterfaceList)) $(LINK2 interface.html#InterfaceBody, $(I InterfaceBody))
+)
+ConditionalDeclaration_production = $(GRAMMAR
+$(GNAME ConditionalDeclaration):
+    $(GLINK Condition) $(I CCDeclarationBlock)
+    $(GLINK Condition) $(I CCDeclarationBlock) $(B else) $(I CCDeclarationBlock)
+    $(GLINK Condition) $(B :) $(I Declarations)
+)
+CCDeclarationBlock_production = $(GRAMMAR
+$(GNAME CCDeclarationBlock):
+    $(LINK2 declaration.html#Declaration, $(I Declaration))
+    $(B {) $(I Declarations) $(B })
+    $(B { })
+)
+Declarations_production = $(GRAMMAR
+$(GNAME Declarations):
+    $(LINK2 declaration.html#Declaration, $(I Declaration))
+    $(LINK2 declaration.html#Declaration, $(I Declaration)) $(I Declarations)
+)
+ConditionalStatement_production = $(GRAMMAR
+$(GNAME ConditionalStatement):
+    $(GLINK Condition) $(LINK2 statement.html#NoScopeNonEmptyStatement, $(I NoScopeNonEmptyStatement))
+    $(GLINK Condition) $(LINK2 statement.html#NoScopeNonEmptyStatement, $(I NoScopeNonEmptyStatement)) $(B else) $(LINK2 statement.html#NoScopeNonEmptyStatement, $(I NoScopeNonEmptyStatement))
+)
+Condition_production = $(GRAMMAR
+$(GNAME Condition):
+    $(LINK2 #version, $(I VersionCondition))
+    $(LINK2 #debug, $(I DebugCondition))
+    $(LINK2 #staticif, $(I StaticIfCondition))
+)
+VersionCondition_production = $(GRAMMAR
+$(GNAME VersionCondition):
+	$(B version $(LPAREN)) $(I Integer) $(B $(RPAREN))
+	$(B version $(LPAREN)) $(I Identifier) $(B $(RPAREN))
+$(V2
+	$(B version $(LPAREN)) $(B unittest) $(B $(RPAREN)))
+)
+VersionSpecification_production = $(GRAMMAR
+$(GNAME VersionSpecification):
+    $(B version =) $(I Identifier) $(B ;)
+    $(B version =) $(I Integer) $(B ;)
+)
+DebugCondition_production = $(GRAMMAR
+$(GNAME DebugCondition):
+    $(B debug)
+    $(B debug $(LPAREN)) $(I Integer) $(B $(RPAREN))
+    $(B debug $(LPAREN)) $(I Identifier) $(B $(RPAREN))
+)
+DebugSpecification_production = $(GRAMMAR
+$(GNAME DebugSpecification):
+    $(B debug =) $(I Identifier) $(B ;)
+    $(B debug =) $(I Integer) $(B ;)
+)
+StaticIfCondition_production = $(GRAMMAR
+$(GNAME StaticIfCondition):
+    $(B static if $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN))
+)
+StaticAssert_production = $(GRAMMAR
+$(GNAME StaticAssert):
+    $(B static assert $(LPAREN)) $(ASSIGNEXPRESSION) $(B $(RPAREN);)
+    $(B static assert $(LPAREN)) $(ASSIGNEXPRESSION) $(B ,) $(ASSIGNEXPRESSION) $(B $(RPAREN);)
+)
+TemplateMixinDeclaration_production = $(GRAMMAR
+$(GNAME TemplateMixinDeclaration):
+	$(V2 $(B mixin)) $(B template) $(TEMPLATEIDENTIFIER) $(B $(LPAREN)) $(TEMPLATEPARAMETERLIST) $(B $(RPAREN)) $(V2 $(GLINK Constraint)$(SUB $(I opt)))
+		$(B {) DeclDefs $(B })
+)
+TemplateMixin_production = $(GRAMMAR
+$(GNAME TemplateMixin):
+	$(B mixin) $(TEMPLATEIDENTIFIER) $(B ;)
+	$(B mixin) $(TEMPLATEIDENTIFIER) $(GLINK MixinIdentifier) $(B ;)
+	$(B mixin) $(TEMPLATEIDENTIFIER) $(B !$(LPAREN)) $(TEMPLATEARGUMENTLIST) $(B $(RPAREN)) $(B ;)
+	$(B mixin) $(TEMPLATEIDENTIFIER) $(B !$(LPAREN)) $(TEMPLATEARGUMENTLIST) $(B $(RPAREN)) $(GLINK MixinIdentifier) $(B ;)
+)
+MixinIdentifier_production = $(GRAMMAR
+$(GNAME MixinIdentifier):
+	$(I Identifier)
+)
+TraitsExpression_production = $(GRAMMAR
+$(GNAME TraitsExpression):
+    $(B __traits) $(B $(LPAREN)) $(I TraitsKeyword) $(B ,) $(I TraitsArguments) $(B $(RPAREN))
+)
+TraitsKeyword_production = $(GRAMMAR
+$(GNAME TraitsKeyword):
+    $(B isAbstractClass)
+    $(B isArithmetic)
+    $(B isAssociativeArray)
+    $(B isFinalClass)
+    $(B isFloating)
+    $(B isIntegral)
+    $(B isScalar)
+    $(B isStaticArray)
+    $(B isUnsigned)
+    $(B isVirtualFunction)
+    $(B isAbstractFunction)
+    $(B isFinalFunction)
+$(V2      $(GBLINK isStaticFunction)
+)    $(GBLINK isRef)
+    $(GBLINK isOut)
+    $(GBLINK isLazy)
+    $(B hasMember)
+$(V2      $(GBLINK identifier)
+)    $(B getMember)
+$(V2      $(GBLINK getOverloads)
+)    $(GBLINK getVirtualFunctions)
+    $(B classInstanceSize)
+    $(GBLINK allMembers)
+    $(GBLINK derivedMembers)
+    $(B isSame)
+    $(B compiles)
+)
+TraitsArguments_production = $(GRAMMAR
+$(GNAME TraitsArguments):
+    $(I TraitsArgument)
+    $(I TraitsArgument) $(B ,) $(I TraitsArguments)
+)
+TraitsArgument_production = $(GRAMMAR
+$(GNAME TraitsArgument):
+    $(I AssignExpression)
+    $(I Type)
+)
+UnitTest_production = $(GRAMMAR
+$(GNAME UnitTest):
+	$(B unittest) $(I FunctionBody)
+)
\ No newline at end of file
